var csInterface = new CSInterface();
try {
var spacingFactor = 2;
var wiggleFactor = 40;
var baseScale = 60;
var scalefactor = 30;
var rotfactor = 45;
var gridStyle = 0;
var updaterOp = 0;
var dist = 0;

var radios = document.getElementById("radios");
var slider_spacing = document.getElementById("range_spacing");
var slider_wiggle = document.getElementById("range_wiggle");
var slider_basescale = document.getElementById("range_basescale");
var slider_scalefactor = document.getElementById("range_scalefactor");
var slider_rotfactor = document.getElementById("range_rotfactor");
var b_random = document.getElementById("b_random");
var b_seq = document.getElementById("b_seq");
var colorboxhidden = true;
var theme = 0;
updateChaos();

slider_spacing.oninput = function() {
    spacingFactor = this.value;
} 
slider_spacing.onchange = function() {
	updaterOp = 0;
    updateChaos();
} 

slider_wiggle.oninput = function() {
    wiggleFactor = this.value;
} 
slider_wiggle.onchange = function() {
	updaterOp = 1;
    updateChaos();
}

slider_basescale.oninput = function() {
	
    baseScale = this.value;
} 
slider_basescale.onchange = function() {
	updaterOp = 99;
    updateChaos();
}

slider_scalefactor.oninput = function() {
    scalefactor = this.value;
} 
slider_scalefactor.onchange = function() {
	updaterOp = 3;
    updateChaos();
}

slider_rotfactor.oninput = function() {
    rotfactor = this.value;
} 
slider_rotfactor.onchange = function() {
	updaterOp = 2;
    updateChaos();
}



function chnagedistribution(d) {
	if ( d === 0 ) {
		b_random.style.backgroundColor = '#08baed';
		b_seq.style.backgroundColor = '#333333';
		b_random.style.color = '#ffffff';
		b_seq.style.color = '#707070';
		b_random.innerHTML = 'Randomize';
		dist = 0;
	} else if ( d === 1 ) {
		b_random.style.backgroundColor = '#333333';
		b_seq.style.backgroundColor = '#08baed';
		b_seq.style.color = '#ffffff';
		b_random.style.color = '#707070';
		b_random.innerHTML = 'Random';
		dist = 1;
	}
	updaterOp = 5;
	updateChaos();
}


function updateChaos() {
	var passingData = function() {
        var def = new $.Deferred();
        csInterface.evalScript('updateChaos('+ spacingFactor + ',' + wiggleFactor + ',' + baseScale + ',' + scalefactor + ',' + rotfactor + ',' + gridStyle + ',' + updaterOp + ',' + dist + ',' + theme + ')', function(n1) {
            def.resolve(n1);
        })

        return def.promise();
    };
    passingData().done(function(msg) {
		msg = msg.split(',');
		//alert(msg[0]);
        if ( msg[0] == 'noselection' ) {
			document.getElementById('console').style.display = "table";
		} else if ( msg[0] == 'nodocument' ) {
			document.getElementById('console-message').innerHTML = '<span class="consoletitle">No Document.</span> Please close the extension, create a new document and select one or more objects. Then launch the Lovely Chaos again';
			document.getElementById('console').style.display = "table";
		}
		if ( msg[1] > 1 ) { 
				document.getElementById('radios').style.opacity = '1';
				document.getElementById('radios').style.pointerEvents = 'auto';
			} else { 
				document.getElementById('radios').style.opacity = '0.3';
				document.getElementById('radios').style.pointerEvents = 'none';
			}
		
		if ( msg[2] == 'true' ) { 
				document.getElementById('colorbox').style.opacity = '1';
				document.getElementById('colorbox').style.pointerEvents = 'auto';
				document.getElementById('qm').style.display = 'none';
			} else { 
				document.getElementById('colorbox').style.opacity = '0.3';
				document.getElementById('colorbox').style.pointerEvents = 'none';
				document.getElementById('qm').style.display = 'block';
			}
        });
}

function updateChaosAgain(){
	updaterOp = 0;
    updateChaos();
}

function changeGrid(i){
	gridStyle = i;
	updaterOp = 0;
	try{
	if ( i == 1 ) {
		document.getElementById('grid1').style.backgroundPosition = '0px 0px';
		document.getElementById('grid2').style.backgroundPosition = '-56px 0px';
		document.getElementById('grid1').style.pointerEvents = 'auto';
		document.getElementById('grid2').style.pointerEvents = 'none';
	} else if ( i == 0 ) {
		document.getElementById('grid1').style.backgroundPosition = '+56px 0px';
		document.getElementById('grid2').style.backgroundPosition = '-0px 0px';
		document.getElementById('grid1').style.pointerEvents = 'none';
		document.getElementById('grid2').style.pointerEvents = 'auto';
	}
	}catch(e) {alert(e)}
	updateChaos();
}

function closeApp(){
	window.__adobe_cep__.closeExtension();
}

} catch(e){alert(e)}

function toggleColors(){
	if ( colorboxhidden ) {
		document.getElementById('colorselector').style.display = 'block';
		colorboxhidden = false;
	} else {
		document.getElementById('colorselector').style.display = 'none';
		colorboxhidden = true;
	}
}

function closeColorbox(){
	document.getElementById('colorselector').style.display = 'none';
		colorboxhidden = true;
}

function changeTheme(t){
	theme = t;
	updaterOp = 6;
	document.getElementById('colorbox').style.backgroundPosition = '0 '+ -t*28 + 'px';
    updateChaos();
	closeColorbox();
}

function randomizeColors() {
	updaterOp = 6;
	updateChaos();
}